
_Display_Init:
	LNK	#18

;Stretch.mbas,44 :: 		sub procedure Display_Init()
;Stretch.mbas,45 :: 		TFT_BLED_Direction = 0           ' Set TFT backlight pin as output
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	BCLR	TRISD2_bit, BitPos(TRISD2_bit+0)
;Stretch.mbas,46 :: 		TFT_Set_Default_Mode()
	CALL	_TFT_Set_Default_Mode
;Stretch.mbas,47 :: 		TFT_Init_ILI9481_8bit(320, 240)  ' Initialize TFT display
	MOV	#240, W11
	MOV	#320, W10
	CALL	_TFT_Init_ILI9481_8bit
;Stretch.mbas,48 :: 		TFT_BLED = 1                     ' Turn on TFT backlight
	BSET	LATD2_bit, BitPos(LATD2_bit+0)
;Stretch.mbas,49 :: 		TFT_Fill_Screen(CL_WHITE)
	MOV	#65535, W10
	CALL	_TFT_Fill_Screen
;Stretch.mbas,50 :: 		TFT_Set_Pen(CL_WHITE, 1)
	MOV	#1, W11
	MOV	#65535, W10
	CALL	_TFT_Set_Pen
;Stretch.mbas,51 :: 		TFT_Set_Brush(1,CL_WHITE,0,0,0,0)
	CLR	W13
	CLR	W12
	MOV	#65535, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;Stretch.mbas,52 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL)
	CLR	W13
	CLR	W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mbas,53 :: 		TFT_Fill_Screen(CL_WHITE)
	MOV	#65535, W10
	CALL	_TFT_Fill_Screen
;Stretch.mbas,54 :: 		TFT_Set_Pen(CL_Black, 1)
	MOV	#1, W11
	CLR	W10
	CALL	_TFT_Set_Pen
;Stretch.mbas,55 :: 		TFT_Line(20, 220, 300, 220)
	MOV	#220, W13
	MOV	#300, W12
	MOV	#220, W11
	MOV	#20, W10
	CALL	_TFT_Line
;Stretch.mbas,56 :: 		TFT_LIne(20,  46, 300,  46)
	MOV	#46, W13
	MOV	#300, W12
	MOV	#46, W11
	MOV	#20, W10
	CALL	_TFT_Line
;Stretch.mbas,57 :: 		TFT_Set_Font(@TFT_defaultFont, CL_RED, FO_HORIZONTAL)
	CLR	W13
	MOV	#63488, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mbas,58 :: 		TFT_Write_Text("Stretch Click", 85, 14)
	ADD	W14, #0, W1
	MOV.B	#83, W0
	MOV.B	W0, [W1++]
	MOV.B	#116, W0
	MOV.B	W0, [W1++]
	MOV.B	#114, W0
	MOV.B	W0, [W1++]
	MOV.B	#101, W0
	MOV.B	W0, [W1++]
	MOV.B	#116, W0
	MOV.B	W0, [W1++]
	MOV.B	#99, W0
	MOV.B	W0, [W1++]
	MOV.B	#104, W0
	MOV.B	W0, [W1++]
	MOV.B	#32, W0
	MOV.B	W0, [W1++]
	MOV.B	#67, W0
	MOV.B	W0, [W1++]
	MOV.B	#108, W0
	MOV.B	W0, [W1++]
	MOV.B	#105, W0
	MOV.B	W0, [W1++]
	MOV.B	#99, W0
	MOV.B	W0, [W1++]
	MOV.B	#107, W0
	MOV.B	W0, [W1++]
	CLR	W0
	MOV.B	W0, [W1++]
	ADD	W14, #0, W0
	MOV	#14, W12
	MOV	#85, W11
	MOV	W0, W10
	CALL	_TFT_Write_Text
;Stretch.mbas,59 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL)
	CLR	W13
	CLR	W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mbas,60 :: 		TFT_Write_Text("EasyPIC Fusion v7", 19, 223)
	ADD	W14, #0, W1
	MOV.B	#69, W0
	MOV.B	W0, [W1++]
	MOV.B	#97, W0
	MOV.B	W0, [W1++]
	MOV.B	#115, W0
	MOV.B	W0, [W1++]
	MOV.B	#121, W0
	MOV.B	W0, [W1++]
	MOV.B	#80, W0
	MOV.B	W0, [W1++]
	MOV.B	#73, W0
	MOV.B	W0, [W1++]
	MOV.B	#67, W0
	MOV.B	W0, [W1++]
	MOV.B	#32, W0
	MOV.B	W0, [W1++]
	MOV.B	#70, W0
	MOV.B	W0, [W1++]
	MOV.B	#117, W0
	MOV.B	W0, [W1++]
	MOV.B	#115, W0
	MOV.B	W0, [W1++]
	MOV.B	#105, W0
	MOV.B	W0, [W1++]
	MOV.B	#111, W0
	MOV.B	W0, [W1++]
	MOV.B	#110, W0
	MOV.B	W0, [W1++]
	MOV.B	#32, W0
	MOV.B	W0, [W1++]
	MOV.B	#118, W0
	MOV.B	W0, [W1++]
	MOV.B	#55, W0
	MOV.B	W0, [W1++]
	CLR	W0
	MOV.B	W0, [W1++]
	ADD	W14, #0, W0
	MOV	#223, W12
	MOV	#19, W11
	MOV	W0, W10
	CALL	_TFT_Write_Text
;Stretch.mbas,61 :: 		TFT_Set_Font(@TFT_defaultFont, CL_RED, FO_HORIZONTAL)
	CLR	W13
	MOV	#63488, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mbas,62 :: 		TFT_Write_Text("www.mikroe.com", 200, 223)
	ADD	W14, #0, W1
	MOV.B	#119, W0
	MOV.B	W0, [W1++]
	MOV.B	#119, W0
	MOV.B	W0, [W1++]
	MOV.B	#119, W0
	MOV.B	W0, [W1++]
	MOV.B	#46, W0
	MOV.B	W0, [W1++]
	MOV.B	#109, W0
	MOV.B	W0, [W1++]
	MOV.B	#105, W0
	MOV.B	W0, [W1++]
	MOV.B	#107, W0
	MOV.B	W0, [W1++]
	MOV.B	#114, W0
	MOV.B	W0, [W1++]
	MOV.B	#111, W0
	MOV.B	W0, [W1++]
	MOV.B	#101, W0
	MOV.B	W0, [W1++]
	MOV.B	#46, W0
	MOV.B	W0, [W1++]
	MOV.B	#99, W0
	MOV.B	W0, [W1++]
	MOV.B	#111, W0
	MOV.B	W0, [W1++]
	MOV.B	#109, W0
	MOV.B	W0, [W1++]
	CLR	W0
	MOV.B	W0, [W1++]
	ADD	W14, #0, W0
	MOV	#223, W12
	MOV	#200, W11
	MOV	W0, W10
	CALL	_TFT_Write_Text
;Stretch.mbas,63 :: 		end sub
L_end_Display_Init:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _Display_Init

_readSensor:

;Stretch.mbas,67 :: 		sub procedure readSensor()
;Stretch.mbas,68 :: 		adc_rd = ADC1_Get_Sample(8)               ' Get ADC value from corresponding channel
	PUSH	W10
	MOV	#8, W10
	CALL	_ADC1_Get_Sample
	MOV	#lo_addr(_adc_rd), W1
	MOV.B	W0, [W1]
;Stretch.mbas,69 :: 		delay_ms(10)                              ' Pause 10ms
	MOV	#13333, W7
L__readSensor2:
	DEC	W7
	BRA NZ	L__readSensor2
	NOP
;Stretch.mbas,70 :: 		end sub
L_end_readSensor:
	POP	W10
	RETURN
; end of _readSensor

_set_adc:

;Stretch.mbas,74 :: 		sub procedure set_adc()
;Stretch.mbas,75 :: 		AD1PCFGL = 0xFFEF          ' Set RA8 as input
	MOV	#65519, W0
	MOV	WREG, AD1PCFGL
;Stretch.mbas,76 :: 		AD1PCFGH = 0xFFFF          ' All other pins are digital
	MOV	#65535, W0
	MOV	WREG, AD1PCFGH
;Stretch.mbas,77 :: 		ADC1_Init()                ' Initialize ADC
	CALL	_ADC1_Init
;Stretch.mbas,78 :: 		Delay_ms(100)
	MOV	#3, W8
	MOV	#2261, W7
L__set_adc5:
	DEC	W7
	BRA NZ	L__set_adc5
	DEC	W8
	BRA NZ	L__set_adc5
;Stretch.mbas,79 :: 		end sub
L_end_set_adc:
	RETURN
; end of _set_adc

_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;Stretch.mbas,81 :: 		main:
;Stretch.mbas,82 :: 		set_adc()                                                         ' Set A/D register
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	CALL	_set_adc
;Stretch.mbas,83 :: 		Display_Init()                                                    ' Initialize TFT
	CALL	_Display_Init
;Stretch.mbas,84 :: 		TFT_Set_Pen(CL_WHITE, 1)
	MOV	#1, W11
	MOV	#65535, W10
	CALL	_TFT_Set_Pen
;Stretch.mbas,85 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL)
	CLR	W13
	CLR	W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mbas,86 :: 		while TRUE
L__main9:
;Stretch.mbas,87 :: 		readSensor()                                                  ' Read sensor
	CALL	_readSensor
;Stretch.mbas,88 :: 		TFT_Set_Font(@TFT_defaultFont, CL_WHITE, FO_HORIZONTAL)
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mbas,89 :: 		TFT_Write_Text(txt, 140, 100)
	MOV	#100, W12
	MOV	#140, W11
	MOV	#lo_addr(_txt), W10
	CALL	_TFT_Write_Text
;Stretch.mbas,90 :: 		WordToStr(adc_rd,txt)                                         ' Conversion integer adc_rd to string txt
	MOV	#lo_addr(_adc_rd), W0
	MOV	#lo_addr(_txt), W11
	ZE	[W0], W10
	CALL	_WordToStr
;Stretch.mbas,91 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL)       ' Display string on TFT
	CLR	W13
	CLR	W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mbas,92 :: 		TFT_Write_Text(txt,140,100)                                   ' Print txt value on TFT
	MOV	#100, W12
	MOV	#140, W11
	MOV	#lo_addr(_txt), W10
	CALL	_TFT_Write_Text
;Stretch.mbas,93 :: 		delay_ms(500)
	MOV	#11, W8
	MOV	#11309, W7
L__main13:
	DEC	W7
	BRA NZ	L__main13
	DEC	W8
	BRA NZ	L__main13
;Stretch.mbas,94 :: 		wend
	GOTO	L__main9
L_end_main:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main
